# -*- coding: utf-8 -*-
#***************************************************************
#   water_level_prediction of a river by LSTM   ver.1 ,60 min  *
#  copyright M. kogoshi & S. Kogoshi, all right reserved       *
#***************************************************************

import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
from keras.models import Sequential
from keras.layers import Dense,  LSTM
from keras import metrics
from sklearn.preprocessing import MinMaxScaler


#df = pd.read_csv('nikkei.csv', encoding="shift_jis")
df = pd.read_csv('water_level_60.csv')
L = len(df)

#Hi = np.array([df.iloc[:, 2]])
#Low = np.array([df.iloc[:, 3]])
#Close = np.array([df.iloc[:, 4]])
Hi = np.array([df.iloc[:, 1]])
Low = np.array([df.iloc[:, 2]])

# ̓f[^Ao̓f[^쐬
Hi = Hi.reshape(-1, 1)  # sɕϊBiz̗vfs~1j
Low = Low.reshape(-1, 1)  # sɕϊBiz̗vfs~1j
#Close = Close.reshape(-1, 1)  # sɕϊBiz̗vfs~1j

Hi1 = Hi[0:L-3, :]  # \Ώۓ3Õf[^
Low1 = Low[0:L-3, :]  # \Ώۓ3Õf[^
#Close1 = Close[0:L-3, :]  # \Ώۓ3Õf[^
Hi2 = Hi[1:L-2, :]  # \Ώۓ2Õf[^
Low2 = Low[1:L-2, :]  # \Ώۓ2Õf[^
#Close2 = Close[1:L-2, :]  # \Ώۓ2Õf[^
Hi3 = Hi[2:L-1, :]  # \Ώۓ̑Of[^
Low3 = Low[2:L-1, :]  # \Ώۓ̑Õf[^
#Close3 = Close[2:L-1, :]  # \Ώۓ̑Õf[^

#X = np.concatenate([Low1, Hi1, Close1, Low2, Hi2, Close2, Low3, Hi3, Close3], axis=1)
X = np.concatenate([Low1, Hi1, Low2, Hi2, Low3, Hi3], axis=1)
#Y = Close[3:L, :]  # \Ώۓ̃f[^
Y = Low[3:L, :]  

scaler = MinMaxScaler()
scaler.fit(X)
X = scaler.transform(X)

scaler1 = MinMaxScaler()
scaler1.fit(Y)
Y = scaler1.transform(Y)

X = np.reshape(X, (X.shape[0], 1, X.shape[1]))
print(X.shape)

#X_train = X[:190, :, :]
#X_test = X[190:, :, :]
#Y_train = Y[:190, :]
#Y_test = Y[190:, :]
X_train = X[:26, :, :]
X_test = X[26:, :, :]
Y_train = Y[:26, :]
Y_test = Y[26:, :]

model = Sequential()
#model.add(LSTM(100, activation='tanh', input_shape=(1, 9), recurrent_activation='hard_sigmoid'))
model.add(LSTM(100, activation='tanh', input_shape=(1, 6), recurrent_activation='hard_sigmoid'))
model.add(Dense(1))

model.compile(loss='mean_squared_error', optimizer='rmsprop', metrics=[metrics.mae])
model.fit(X_train, Y_train, epochs=100, batch_size=1, verbose=2)
Predict = model.predict(X_test, verbose=1)

# IWĩXP[ɖ߂A^CCfbNXtB
Y_train = scaler1.inverse_transform(Y_train)
#Y_train = pd.DataFrame(Y_train)
#Y_train.index = pd.to_datetime(df.iloc[3:193,0])
#Y_train.index = pd.to_datetime(df.iloc[3:148,0])

Y_test = scaler1.inverse_transform(Y_test)
#Y_test = pd.DataFrame(Y_test)
#Y_test.index = pd.to_datetime(df.iloc[193:,0])
#Y_test.index = pd.to_datetime(df.iloc[148:,0])

#Predict = scaler1.inverse_transform(Predict)
y_pred = scaler1.inverse_transform(Predict)
#Predict = pd.DataFrame(Predict)
#Predict.index=pd.to_datetime(df.iloc[193:,0])
x_axis=df.iloc[29:,0]
x_axis=pd.DataFrame(x_axis)

data1 = np.c_[Y_test,y_pred]
data1 = pd.DataFrame(data1)

# save prediction
np.savetxt('out50.csv',data1,delimiter=',')

plt.plot(data1)

plt.figure(figsize=(15,10))
#plt.plot(Y_test, label = 'Test')
#plt.plot(Predict, label = 'Prediction')
#plt.legend(loc='best')
plt.show()